Index: LMDZ5/branches/testing/libf/dyn3dmem/addfi_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/addfi_loc.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/addfi_loc.F	(revision 1999)
@@ -55,15 +55,19 @@
 c    -----------
 c
-      REAL pdt
-c
-      REAL pvcov(ijb_v:ije_v,llm),pucov(ijb_u:ije_u,llm)
-      REAL pteta(ijb_u:ije_u,llm),pq(ijb_u:ije_u,llm,nqtot)
-      REAL pps(ijb_u:ije_u)
-c
-      REAL pdvfi(ijb_v:ije_v,llm),pdufi(ijb_u:ije_u,llm)
-      REAL pdqfi(ijb_u:ije_u,llm,nqtot),pdhfi(ijb_u:ije_u,llm)
-      REAL pdpfi(ijb_u:ije_u)
-c
-      LOGICAL leapf,forward
+      REAL,INTENT(IN) :: pdt ! time step for the integration (s)
+c
+      REAL,INTENT(INOUT) :: pvcov(ijb_v:ije_v,llm) ! covariant meridional wind
+      REAL,INTENT(INOUT) :: pucov(ijb_u:ije_u,llm) ! covariant zonal wind
+      REAL,INTENT(INOUT) :: pteta(ijb_u:ije_u,llm) ! potential temperature
+      REAL,INTENT(INOUT) :: pq(ijb_u:ije_u,llm,nqtot) ! tracers
+      REAL,INTENT(INOUT) :: pps(ijb_u:ije_u) ! surface pressure (Pa)
+c respective tendencies (.../s) to add
+      REAL,INTENT(IN) :: pdvfi(ijb_v:ije_v,llm)
+      REAL,INTENT(IN) :: pdufi(ijb_u:ije_u,llm)
+      REAL,INTENT(IN) :: pdqfi(ijb_u:ije_u,llm,nqtot)
+      REAL,INTENT(IN) :: pdhfi(ijb_u:ije_u,llm)
+      REAL,INTENT(IN) :: pdpfi(ijb_u:ije_u)
+c
+      LOGICAL,INTENT(IN) :: leapf,forward ! not used
 c
 c
@@ -73,7 +77,6 @@
       REAL xpn(iim),xps(iim),tpn,tps
       INTEGER j,k,iq,ij
-      REAL qtestw, qtestt
-      PARAMETER ( qtestw = 1.0e-15 )
-      PARAMETER ( qtestt = 1.0e-40 )
+      REAL,PARAMETER :: qtestw = 1.0e-15
+      REAL,PARAMETER :: qtestt = 1.0e-40
 
       REAL SSUM
Index: LMDZ5/branches/testing/libf/dyn3dmem/advtrac_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/advtrac_loc.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/advtrac_loc.F	(revision 1999)
@@ -24,7 +24,7 @@
       USE Vampir
       USE times
-      USE infotrac
-      USE control_mod
-      USE advtrac_mod
+      USE infotrac, ONLY: nqtot, iadv
+      USE control_mod, ONLY: iapp_tracvl, day_step, planet_type
+      USE advtrac_mod, ONLY: finmasse
       IMPLICIT NONE
 c
Index: LMDZ5/branches/testing/libf/dyn3dmem/caldyn_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/caldyn_loc.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/caldyn_loc.F	(revision 1999)
@@ -1,7 +1,5 @@
 !
-! $Header$
+! $Id: $
 !
-c
-c
 #undef DEBUG_IO
 !#define DEBUG_IO
@@ -12,23 +10,24 @@
       USE parallel_lmdz
       USE Write_Field_loc
-      USE caldyn_mod
+      USE caldyn_mod, ONLY: vcont, ucont, ang, p, massebx, masseby,
+     &                      vorpot, ecin, bern, massebxy, convm
       
       IMPLICIT NONE
 
-c=======================================================================
-c
-c  Auteur :  P. Le Van
-c
-c   Objet:
-c   ------
-c
-c   Calcul des tendances dynamiques.
-c
-c Modif 04/93 F.Forget
-c=======================================================================
+!=======================================================================
+!
+!  Auteur :  P. Le Van
+!
+!   Objet:
+!   ------
+!
+!   Calcul des tendances dynamiques.
+!
+! Modif 04/93 F.Forget
+!=======================================================================
 
-c-----------------------------------------------------------------------
-c   0. Declarations:
-c   ----------------
+!-----------------------------------------------------------------------
+!   0. Declarations:
+!   ----------------
 
 #include "dimensions.h"
@@ -38,39 +37,54 @@
 #include "comgeom.h"
 
-c   Arguments:
-c   ----------
+!   Arguments:
+!   ----------
 
-      LOGICAL conser
+      LOGICAL,INTENT(IN) :: conser ! triggers printing some diagnostics ! not used
+      INTEGER,INTENT(IN) :: itau ! time step index ! not used
+      REAL,INTENT(IN) :: vcov(ijb_v:ije_v,llm) ! covariant meridional wind
+      REAL,INTENT(IN) :: ucov(ijb_u:ije_u,llm) ! covariant zonal wind
+      REAL,INTENT(IN) :: teta(ijb_u:ije_u,llm) ! potential temperature
+      REAL,INTENT(IN) :: ps(ijb_u:ije_u) ! surface pressure
+      REAL,INTENT(IN) :: phis(ijb_u:ije_u) ! geopotential at the surface
+      REAL,INTENT(IN) :: pk(iip1,jjb_u:jje_u,llm) ! Exner at mid-layer
+      REAL,INTENT(IN) :: pkf(ijb_u:ije_u,llm) ! filtered Exner
+      REAL,INTENT(IN) :: phi(ijb_u:ije_u,llm) ! geopotential
+      REAL,INTENT(OUT) :: masse(ijb_u:ije_u,llm) ! air mass
+      REAL,INTENT(OUT) :: dv(ijb_v:ije_v,llm) ! tendency on vcov
+      REAL,INTENT(OUT) :: du(ijb_u:ije_u,llm) ! tendency on ucov
+      REAL,INTENT(OUT) :: dteta(ijb_u:ije_u,llm) ! tenddency on teta
+      REAL,INTENT(OUT) :: dp(ijb_u:ije_u) ! tendency on ps
+      REAL,INTENT(OUT) :: w(ijb_u:ije_u,llm) ! vertical velocity
+      REAL,INTENT(OUT) :: pbaru(ijb_u:ije_u,llm) ! mass flux in the zonal direction
+      REAL,INTENT(OUT) :: pbarv(ijb_v:ije_v,llm) ! mass flux in the meridional direction
+      REAL,INTENT(IN) :: time ! current time
 
-      INTEGER itau
-      REAL vcov(ijb_v:ije_v,llm),ucov(ijb_u:ije_u,llm)
-      REAL teta(ijb_u:ije_u,llm)
-      REAL ps(ijb_u:ije_u),phis(ijb_u:ije_u)
-      REAL pk(iip1,jjb_u:jje_u,llm),pkf(ijb_u:ije_u,llm)
-      REAL phi(ijb_u:ije_u,llm),masse(ijb_u:ije_u,llm)
-      REAL dv(ijb_v:ije_v,llm),du(ijb_u:ije_u,llm)
-      REAL dteta(ijb_u:ije_u,llm),dp(ijb_u:ije_u)
-      REAL w(ijb_u:ije_u,llm)
-      REAL pbaru(ijb_u:ije_u,llm),pbarv(ijb_v:ije_v,llm)
-      REAL time
-
-c   Local:
-c   ------
+!   Local:
+!   ------
 
       INTEGER   ij,l,ijb,ije,ierr
 
 
-c-----------------------------------------------------------------------
-c   Calcul des tendances dynamiques:
-c   --------------------------------
+!-----------------------------------------------------------------------
+!   Compute dynamical tendencies:
+!--------------------------------
+
+      ! compute contravariant winds ucont() and vcont
       CALL covcont_loc  ( llm    , ucov    , vcov , ucont, vcont     )
+      ! compute pressure p()
       CALL pression_loc ( ip1jmp1, ap      , bp   ,  ps  , p         )
 cym      CALL psextbar (   ps   , psexbarxy                          )
 c$OMP BARRIER
+      ! compute mass in each atmospheric mesh: masse()
       CALL massdair_loc (    p   , masse                             )
+      ! compute X and Y-averages of mass, massebx() and masseby()
       CALL massbar_loc  (   masse, massebx , masseby                 )
+      ! compute XY-average of mass, massebxy()
       call massbarxy_loc(   masse, massebxy                          )
+      ! compute mass fluxes pbaru() and pbarv()
       CALL flumass_loc  ( massebx, masseby,vcont,ucont,pbaru,pbarv   )
+      ! compute dteta() , horizontal converging flux of theta
       CALL dteta1_loc   (   teta , pbaru   , pbarv, dteta            )
+      ! compute convm(), horizontal converging flux of mass
       CALL convmas1_loc  (   pbaru, pbarv   , convm                  )
 c$OMP BARRIER      
@@ -95,5 +109,5 @@
       ijb=ij_begin
       ije=ij_end
-            
+      ! compute pressure variation due to mass convergence
       DO ij =ijb, ije
          dp( ij ) = convm( ij,1 ) / airesurg( ij )
@@ -101,6 +115,10 @@
 c$OMP END MASTER
 c$OMP BARRIER
+      
+      ! compute vertical velocity w()
       CALL vitvert_loc ( convm  , w                                )
+      ! compute potential vorticity vorpot()
       CALL tourpot_loc ( vcov   , ucov  , massebxy  , vorpot       )
+      ! compute rotation induced du() and dv()
       CALL dudv1_loc   ( vorpot , pbaru , pbarv     , du     , dv  )
 
@@ -111,6 +129,10 @@
       call WriteField_v('dv',dv)
 #endif      
+      
+      ! compute kinetic energy ecin()
       CALL enercin_loc ( vcov   , ucov  , vcont   , ucont  , ecin  )
+      ! compute Bernouilli function bern()
       CALL bernoui_loc ( ip1jmp1, llm   , phi       , ecin   , bern)
+      ! compute and add du() and dv() contributions from Bernouilli and pressure
       CALL dudv2_loc   ( teta   , pkf   , bern      , du     , dv  )
 
@@ -137,4 +159,5 @@
 c$OMP END DO
 
+      ! compute vertical advection contributions to du(), dv() and dteta()
       CALL advect_new_loc(ang,vcov,teta,w,massebx,masseby,du,dv,dteta) 
 
@@ -158,4 +181,5 @@
 c$OMP END DO NOWAIT      
 
+! Ehouarn: NB: output of control variables not implemented...
 
       RETURN
Index: LMDZ5/branches/testing/libf/dyn3dmem/calfis_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/calfis_loc.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/calfis_loc.F	(revision 1999)
@@ -41,6 +41,6 @@
       Use Write_field_p
       USE Times
-      USE infotrac
-      USE control_mod
+      USE infotrac, ONLY: nqtot, niadv, tname
+      USE control_mod, ONLY: planet_type, nsplit_phys
 
       IMPLICIT NONE
@@ -115,34 +115,33 @@
 c    Arguments :
 c    -----------
-      LOGICAL  lafin
-!      REAL heure
-      REAL, intent(in):: jD_cur, jH_cur
-      REAL pvcov(iip1,jjb_v:jje_v,llm)
-      REAL pucov(iip1,jjb_u:jje_u,llm)
-      REAL pteta(iip1,jjb_u:jje_u,llm)
-      REAL pmasse(iip1,jjb_u:jje_u,llm)
-      REAL pq(iip1,jjb_u:jje_u,llm,nqtot)
-      REAL pphis(iip1,jjb_u:jje_u)
-      REAL pphi(iip1,jjb_u:jje_u,llm)
-c
-      REAL pdvcov(iip1,jjb_v:jje_v,llm)
-      REAL pducov(iip1,jjb_u:jje_u,llm)
-      REAL pdteta(iip1,jjb_u:jje_u,llm)
-      REAL pdq(iip1,jjb_u:jje_u,llm,nqtot)
-      REAL flxw(iip1,jjb_u:jje_u,llm)  ! Flux de masse verticale sur la grille dynamique
-c
-      REAL pps(iip1,jjb_u:jje_u)
-      REAL pp(iip1,jjb_u:jje_u,llmp1)
-      REAL ppk(iip1,jjb_u:jje_u,llm)
-c
-      REAL pdvfi(iip1,jjb_v:jje_v,llm)
-      REAL pdufi(iip1,jjb_u:jje_u,llm)
-      REAL pdhfi(iip1,jjb_u:jje_u,llm)
-      REAL pdqfi(iip1,jjb_u:jje_u,llm,nqtot)
-      REAL pdpsfi(iip1,jjb_u:jje_u)
-
-      INTEGER        longcles
-      PARAMETER    ( longcles = 20 )
-      REAL clesphy0( longcles )
+      LOGICAL,INTENT(IN) ::  lafin ! .true. for the very last call to physics
+      REAL,INTENT(IN):: jD_cur, jH_cur
+      REAL,INTENT(IN):: pvcov(iip1,jjb_v:jje_v,llm) ! covariant meridional velocity
+      REAL,INTENT(IN):: pucov(iip1,jjb_u:jje_u,llm) ! covariant zonal velocity
+      REAL,INTENT(IN):: pteta(iip1,jjb_u:jje_u,llm) ! potential temperature
+      REAL,INTENT(IN):: pmasse(iip1,jjb_u:jje_u,llm) ! mass in each cell ! not used
+      REAL,INTENT(IN):: pq(iip1,jjb_u:jje_u,llm,nqtot) ! tracers
+      REAL,INTENT(IN):: pphis(iip1,jjb_u:jje_u) ! surface geopotential
+      REAL,INTENT(IN):: pphi(iip1,jjb_u:jje_u,llm) ! geopotential
+
+      REAL,INTENT(IN) :: pdvcov(iip1,jjb_v:jje_v,llm) ! dynamical tendency on vcov ! not used
+      REAL,INTENT(IN) :: pducov(iip1,jjb_u:jje_u,llm) ! dynamical tendency on ucov
+      REAL,INTENT(IN) :: pdteta(iip1,jjb_u:jje_u,llm) ! dynamical tendency on teta ! not used
+      REAL,INTENT(IN) :: pdq(iip1,jjb_u:jje_u,llm,nqtot) ! dynamical tendency on tracers ! not used
+
+      REAL,INTENT(IN) :: pps(iip1,jjb_u:jje_u) ! surface pressure (Pa)
+      REAL,INTENT(IN) :: pp(iip1,jjb_u:jje_u,llmp1) ! pressure at mesh interfaces (Pa)
+      REAL,INTENT(IN) :: ppk(iip1,jjb_u:jje_u,llm) ! Exner at mid-layer
+      REAL,INTENT(IN) :: flxw(iip1,jjb_u:jje_u,llm)  ! Vertical mass flux on dynamics grid
+
+      ! tendencies (in */s) from the physics
+      REAL,INTENT(OUT) :: pdvfi(iip1,jjb_v:jje_v,llm) ! tendency on covariant meridional wind
+      REAL,INTENT(OUT) :: pdufi(iip1,jjb_u:jje_u,llm) ! tendency on covariant zonal wind
+      REAL,INTENT(OUT) :: pdhfi(iip1,jjb_u:jje_u,llm) ! tendency on potential temperature (K/s)
+      REAL,INTENT(OUT) :: pdqfi(iip1,jjb_u:jje_u,llm,nqtot) ! tendency on tracers
+      REAL,INTENT(OUT) :: pdpsfi(iip1,jjb_u:jje_u) ! tendency on surface pressure (Pa/s)
+
+      INTEGER,PARAMETER :: longcles = 20
+      REAL,INTENT(IN) :: clesphy0( longcles ) ! unused
 
 
@@ -221,8 +220,6 @@
 c
 cIM diagnostique PVteta, Amip2
-      INTEGER ntetaSTD
-      PARAMETER(ntetaSTD=3)
-      REAL rtetaSTD(ntetaSTD)
-      DATA rtetaSTD/350., 380., 405./ ! Earth-specific values, beware !!
+      INTEGER,PARAMETER :: ntetaSTD=3
+      REAL,SAVE :: rtetaSTD(ntetaSTD)=(/350.,380.,405./) ! Earth-specific, beware !!
       REAL PVteta(klon,ntetaSTD)
       
@@ -230,7 +227,5 @@
       REAL SSUM
 
-      LOGICAL firstcal, debut
-      DATA firstcal/.true./
-      SAVE firstcal,debut
+      LOGICAL,SAVE :: firstcal=.true., debut=.true.
 c$OMP THREADPRIVATE(firstcal,debut)
       
Index: LMDZ5/branches/testing/libf/dyn3dmem/call_calfis_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/call_calfis_mod.F90	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/call_calfis_mod.F90	(revision 1999)
@@ -91,15 +91,15 @@
     INCLUDE "iniprint.h"
 
-    REAL    :: clesphy0( : )    
-    INTEGER :: itau
-    LOGICAL :: lafin 
-    REAL :: ucov_dyn(ijb_u:ije_u,llm)
-    REAL :: vcov_dyn(ijb_v:ije_v,llm) 
-    REAL :: teta_dyn(ijb_u:ije_u,llm) 
-    REAL :: masse_dyn(ijb_u:ije_u,llm) 
-    REAL :: ps_dyn(ijb_u:ije_u) 
-    REAL :: phis_dyn(ijb_u:ije_u) 
-    REAL :: q_dyn(ijb_u:ije_u,llm,nqtot) 
-    REAL :: flxw_dyn(ijb_u:ije_u,llm) 
+    INTEGER,INTENT(IN) :: itau ! (time) iteration step number
+    LOGICAL,INTENT(IN) :: lafin ! .true. if final time step
+    REAL,INTENT(IN) :: clesphy0( : ) ! not used    
+    REAL,INTENT(INOUT) :: ucov_dyn(ijb_u:ije_u,llm) ! covariant zonal wind
+    REAL,INTENT(INOUT) :: vcov_dyn(ijb_v:ije_v,llm) ! covariant meridional wind
+    REAL,INTENT(INOUT) :: teta_dyn(ijb_u:ije_u,llm) ! potential temperature
+    REAL,INTENT(INOUT) :: masse_dyn(ijb_u:ije_u,llm) ! air mass
+    REAL,INTENT(INOUT) :: ps_dyn(ijb_u:ije_u) ! surface pressure
+    REAL,INTENT(INOUT) :: phis_dyn(ijb_u:ije_u) ! surface geopotential
+    REAL,INTENT(INOUT) :: q_dyn(ijb_u:ije_u,llm,nqtot) ! advected tracers
+    REAL,INTENT(INOUT) :: flxw_dyn(ijb_u:ije_u,llm) ! vertical mass flux
 
     REAL :: dufi_tmp(iip1,llm)    
@@ -134,5 +134,7 @@
   !$OMP MASTER
     CALL suspend_timer(timer_caldyn)
-    WRITE(lunout,*) 'leapfrog_p: Entree dans la physique : Iteration No ',itau
+    IF (prt_level >= 10) THEN
+      WRITE(lunout,*) 'leapfrog_p: Entree dans la physique : Iteration No ',itau
+    ENDIF
   !$OMP END MASTER
    
@@ -335,4 +337,15 @@
                     ucov, vcov, teta , q   ,ps ,            &
                     dufi, dvfi, dtetafi , dqfi ,dpfi  )
+    ! since addfi updates ps(), also update p(), masse() and pk()
+    CALL pression_loc(ip1jmp1,ap,bp,ps,p)
+!$OMP BARRIER
+    CALL massdair_loc(p,masse)
+!$OMP BARRIER
+    if (pressure_exner) then
+      CALL exner_hyb_loc(ijnb_u,ps,p,alpha,beta,pks,pk,pkf)
+    else 
+      CALL exner_milieu_loc(ijnb_u,ps,p,beta,pks,pk,pkf)
+    endif
+!$OMP BARRIER
 
 #ifdef DEBUG_IO    
Index: LMDZ5/branches/testing/libf/dyn3dmem/call_dissip_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/call_dissip_mod.F90	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/call_dissip_mod.F90	(revision 1999)
@@ -87,10 +87,10 @@
   IMPLICIT NONE
     INCLUDE 'comgeom.h'
-    REAL :: ucov_dyn(ijb_u:ije_u,llm)
-    REAL :: vcov_dyn(ijb_v:ije_v,llm)
-    REAL :: teta_dyn(ijb_u:ije_u,llm)
-    REAL :: p_dyn(ijb_u:ije_u,llmp1 )
-    REAL :: pk_dyn(ijb_u:ije_u,llm)
-    REAL :: ps_dyn(ijb_u:ije_u)
+    REAL,INTENT(INOUT) :: ucov_dyn(ijb_u:ije_u,llm) ! covariant zonal wind
+    REAL,INTENT(INOUT) :: vcov_dyn(ijb_v:ije_v,llm) ! covariant meridional wind
+    REAL,INTENT(INOUT) :: teta_dyn(ijb_u:ije_u,llm) ! covariant meridional wind
+    REAL,INTENT(INOUT) :: p_dyn(ijb_u:ije_u,llmp1 ) ! pressure at interlayer
+    REAL,INTENT(INOUT) :: pk_dyn(ijb_u:ije_u,llm) ! Exner at midlayer
+    REAL,INTENT(INOUT) :: ps_dyn(ijb_u:ije_u) ! surface pressure
     REAL :: tppn(iim),tpps(iim)
     REAL :: tpn,tps
Index: LMDZ5/branches/testing/libf/dyn3dmem/ce0l.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/ce0l.F90	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/ce0l.F90	(revision 1999)
@@ -115,12 +115,10 @@
   END IF
 
-  IF (grilles_gcm_netcdf) THEN
-     WRITE(lunout,'(//)')
-     WRITE(lunout,*) '  ***************************  '
-     WRITE(lunout,*) '  ***  grilles_gcm_netcdf ***  '
-     WRITE(lunout,*) '  ***************************  '
-     WRITE(lunout,'(//)')
-     CALL grilles_gcm_netcdf_sub(masque,phis)
-  END IF
+  WRITE(lunout,'(//)')
+  WRITE(lunout,*) '  ***************************  '
+  WRITE(lunout,*) '  ***  grilles_gcm_netcdf ***  '
+  WRITE(lunout,*) '  ***************************  '
+  WRITE(lunout,'(//)')
+  CALL grilles_gcm_netcdf_sub(masque,phis)
   
 #ifdef CPP_MPI
Index: LMDZ5/branches/testing/libf/dyn3dmem/conf_gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/conf_gcm.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/conf_gcm.F	(revision 1999)
@@ -944,10 +944,4 @@
       ok_etat0 = .TRUE.
       CALL getin('ok_etat0',ok_etat0)
-
-!Config  Key  = grilles_gcm_netcdf
-!Config  Desc = creation de fichier grilles_gcm.nc dans create_etat0_limit
-!Config  Def  = n
-      grilles_gcm_netcdf = .FALSE.
-      CALL getin('grilles_gcm_netcdf',grilles_gcm_netcdf)
 
       write(lunout,*)' #########################################'
@@ -999,5 +993,4 @@
       write(lunout,*)' ok_limit = ', ok_limit
       write(lunout,*)' ok_etat0 = ', ok_etat0
-      write(lunout,*)' grilles_gcm_netcdf = ', grilles_gcm_netcdf
 c
       RETURN
Index: LMDZ5/branches/testing/libf/dyn3dmem/dissip_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/dissip_loc.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/dissip_loc.F	(revision 1999)
@@ -1,7 +1,10 @@
+!
+! $Id: $
+!
       SUBROUTINE dissip_loc( vcov,ucov,teta,p, dv,du,dh )
 c
       USE parallel_lmdz
       USE write_field_loc
-      USE dissip_mod
+      USE dissip_mod, ONLY: dissip_allocate
       IMPLICIT NONE
 
@@ -35,8 +38,12 @@
 c   ----------
 
-      REAL vcov(ijb_v:ije_v,llm),ucov(ijb_u:ije_u,llm)
-      REAL teta(ijb_u:ije_u,llm)
-      REAL  p( ijb_u:ije_u,llmp1 )
-      REAL dv(ijb_v:ije_v,llm),du(ijb_u:ije_u,llm),dh(ijb_u:ije_u,llm)
+      REAL,INTENT(IN) :: vcov(ijb_v:ije_v,llm) ! covariant meridional wind
+      REAL,INTENT(IN) :: ucov(ijb_u:ije_u,llm) ! covariant zonal wind
+      REAL,INTENT(IN) :: teta(ijb_u:ije_u,llm) ! potential temperature
+      REAL,INTENT(IN) :: p(ijb_u:ije_u,llmp1) ! interlayer pressure
+      ! tendencies (.../s) on covariant winds and potential temperature
+      REAL,INTENT(OUT) :: dv(ijb_v:ije_v,llm)
+      REAL,INTENT(OUT) :: du(ijb_u:ije_u,llm)
+      REAL,INTENT(OUT) :: dh(ijb_u:ije_u,llm)
 
 c   Local:
Index: LMDZ5/branches/testing/libf/dyn3dmem/dynetat0_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/dynetat0_loc.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/dynetat0_loc.F	(revision 1999)
@@ -68,5 +68,5 @@
      &  'dynetat0_loc: Pb d''ouverture du fichier start.nc'
         write(lunout,*)' ierr = ', ierr
-        CALL ABORT
+        CALL ABORT_GCM("DYNETAT0", "", 1)
       ENDIF
 
@@ -75,5 +75,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <controle> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -84,5 +84,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echoue pour <controle>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -158,5 +158,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <rlonu> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -167,5 +167,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <rlonu>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -173,5 +173,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <rlatu> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -182,5 +182,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <rlatu>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -188,5 +188,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <rlonv> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -197,5 +197,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <rlonv>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -203,5 +203,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <rlatv> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -212,5 +212,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour rlatv"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -218,5 +218,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <cu> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -227,5 +227,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <cu>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -233,5 +233,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <cv> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -242,5 +242,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <cv>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -248,5 +248,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <aire> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -257,5 +257,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <aire>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
       
@@ -265,5 +265,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <phisinit> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -274,5 +274,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <phisinit>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
       phis(ijb_u:ije_u)=phis_glo(ijb_u:ije_u)
@@ -286,5 +286,5 @@
          IF (ierr .NE. NF_NOERR) THEN
             write(lunout,*)"dynetat0: Le champ <Time> est absent"
-            CALL abort
+            CALL abort_gcm("dynetat0", "", 1)
          ENDIF
       ENDIF
@@ -296,5 +296,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee <temps>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -302,5 +302,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <ucov> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
       
@@ -314,5 +314,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <ucov>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -324,5 +324,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <vcov> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -333,5 +333,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <vcov>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
       vcov(ijb_v:ije_v,:)=vcov_glo(ijb_v:ije_v,:)
@@ -342,5 +342,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <teta> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -351,5 +351,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <teta>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
@@ -375,5 +375,5 @@
             write(lunout,*)
      &      "dynetat0_loc: Lecture echouee pour "//tname(iq)
-            CALL abort
+            CALL abort_gcm("dynetat0", "", 1)
           ENDIF
         q(ijb_u:ije_u,:,iq)=q_glo(ijb_u:ije_u,:)
@@ -388,5 +388,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <masse> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -397,5 +397,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <masse>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
       masse(ijb_u:ije_u,:)=masse_glo(ijb_u:ije_u,:)
@@ -406,5 +406,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Le champ <ps> est absent"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 #ifdef NC_DOUBLE
@@ -415,5 +415,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynetat0_loc: Lecture echouee pour <ps>"
-         CALL abort
+         CALL abort_gcm("dynetat0", "", 1)
       ENDIF
 
Index: LMDZ5/branches/testing/libf/dyn3dmem/dynredem_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/dynredem_loc.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/dynredem_loc.F	(revision 1999)
@@ -138,5 +138,5 @@
      &                  //trim(fichnom)
          write(lunout,*)' ierr = ', ierr
-         CALL ABORT
+         CALL ABORT_GCM("DYNREDEM0", "", 1)
       ENDIF
 c
@@ -588,5 +588,5 @@
       IF (ierr .NE. NF_NOERR) THEN
          write(lunout,*)"dynredem1: Pb. d ouverture "//trim(fichnom)
-         CALL abort
+         CALL abort_gcm("dynredem1", "", 1)
       ENDIF
 
Index: LMDZ5/branches/testing/libf/dyn3dmem/fxhyp.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/fxhyp.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/fxhyp.F	(revision 1999)
@@ -48,18 +48,18 @@
 c
        REAL   dzoom
-       REAL*8 xlon(iip1),xprimm(iip1),xuv
-       REAL*8 xtild(0:nmax2)
-       REAL*8 fhyp(0:nmax2),ffdx,beta,Xprimt(0:nmax2)
-       REAL*8 Xf(0:nmax2),xxpr(0:nmax2)
-       REAL*8 xvrai(iip1),xxprim(iip1) 
-       REAL*8 pi,depi,epsilon,xzoom,fa,fb
-       REAL*8 Xf1, Xfi , a0,a1,a2,a3,xi2
+       REAL(KIND=8) xlon(iip1),xprimm(iip1),xuv
+       REAL(KIND=8) xtild(0:nmax2)
+       REAL(KIND=8) fhyp(0:nmax2),ffdx,beta,Xprimt(0:nmax2)
+       REAL(KIND=8) Xf(0:nmax2),xxpr(0:nmax2)
+       REAL(KIND=8) xvrai(iip1),xxprim(iip1) 
+       REAL(KIND=8) pi,depi,epsilon,xzoom,fa,fb
+       REAL(KIND=8) Xf1, Xfi , a0,a1,a2,a3,xi2
        INTEGER i,it,ik,iter,ii,idif,ii1,ii2
-       REAL*8 xi,xo1,xmoy,xlon2,fxm,Xprimin
-       REAL*8 champmin,champmax,decalx
+       REAL(KIND=8) xi,xo1,xmoy,xlon2,fxm,Xprimin
+       REAL(KIND=8) champmin,champmax,decalx
        INTEGER is2
        SAVE is2
 
-       REAL*8 heavyside
+       REAL(KIND=8) heavyside
 
        pi       = 2. * ASIN(1.)
@@ -157,5 +157,5 @@
         WRITE(6,*)'Modifier les valeurs de  grossismx ,tau ou dzoomx ',
      , ' et relancer ! ***  '
-        CALL ABORT
+        CALL ABORT_GCM("FXHYP", "", 1)
        ENDIF
 c
@@ -290,4 +290,5 @@
          xxprim(1)   = xxprim(iip1)
        ENDIF
+
        DO i = 1 , iim
         xlon(i)     = xvrai(i)
Index: LMDZ5/branches/testing/libf/dyn3dmem/gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/gcm.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/gcm.F	(revision 1999)
@@ -548,7 +548,7 @@
 c$OMP END PARALLEL
 
-      OPEN(unit=5487,file='ok_lmdz',status='replace')
-      WRITE(5487,*) 'ok_lmdz'
-      CLOSE(5487)
+!      OPEN(unit=5487,file='ok_lmdz',status='replace')
+!      WRITE(5487,*) 'ok_lmdz'
+!      CLOSE(5487)
       END
 
Index: LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 1910)
+++ LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 1999)
@@ -80,17 +80,18 @@
 !      include "mpif.h"
       
-      INTEGER         longcles
-      PARAMETER     ( longcles = 20 )
-      REAL  clesphy0( longcles )
+      INTEGER,PARAMETER :: longcles = 20
+      REAL,INTENT(IN) :: clesphy0( longcles ) ! not used
+      REAL,INTENT(IN) :: time_0 ! not used
+
+c   dynamical variables:
+      REAL,INTENT(IN) :: ucov0(ijb_u:ije_u,llm)    ! zonal covariant wind
+      REAL,INTENT(IN) :: vcov0(ijb_v:ije_v,llm)    ! meridional covariant wind
+      REAL,INTENT(IN) :: teta0(ijb_u:ije_u,llm)    ! potential temperature
+      REAL,INTENT(IN) :: q0(ijb_u:ije_u,llm,nqtot) ! advected tracers
+      REAL,INTENT(IN) :: ps0(ijb_u:ije_u)          ! surface pressure (Pa)
+      REAL,INTENT(IN) :: masse0(ijb_u:ije_u,llm)   ! air mass
+      REAL,INTENT(IN) :: phis0(ijb_u:ije_u)        ! geopotentiat at the surface
 
       real zqmin,zqmax
-
-c   variables dynamiques
-      REAL :: vcov0(ijb_v:ije_v,llm),ucov0(ijb_u:ije_u,llm) ! vents covariants
-      REAL :: teta0(ijb_u:ije_u,llm)                 ! temperature potentielle 
-      REAL :: q0(ijb_u:ije_u,llm,nqtot)              ! champs advectes
-      REAL :: ps0(ijb_u:ije_u)                       ! pression  au sol
-      REAL :: masse0(ijb_u:ije_u,llm)                ! masse d'air
-      REAL :: phis0(ijb_u:ije_u)                     ! geopotentiel au sol
 
 !      REAL,SAVE,ALLOCATABLE :: p (:,:  )               ! pression aux interfac.des couches
@@ -133,6 +134,5 @@
       REAL       time 
 
-      REAL  SSUM
-      REAL time_0 
+      REAL  SSUM 
 !      REAL,SAVE,ALLOCATABLE :: finvmaold(:,:)
 
@@ -670,6 +670,5 @@
       
       IF( forward. OR . leapf )  THEN
- 
- 
+! Ehouarn: NB: fields sent to advtrac are those at the beginning of the time step
          CALL caladvtrac_loc(q,pbaru,pbarv,
      *        p, masse, dq,  teta,
@@ -680,5 +679,6 @@
 !      enddo
 
-c
+! Ehouarn: Storage of mass flux for off-line tracers... not implemented...
+
       ENDIF ! of IF( forward. OR . leapf )
 
@@ -1140,4 +1140,6 @@
         endif
 c$OMP BARRIER
+        CALL massdair_loc(p,masse)
+c$OMP BARRIER
 
 cc$OMP END PARALLEL
